EnumMapSerializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.ser.std

## Class EnumMapSerializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonSerializer<T>
  - - org.codehaus.jackson.map.ser.std.SerializerBase<T>
    - - org.codehaus.jackson.map.ser.std.ContainerSerializerBase<EnumMap<? extends Enum<?>,?>>
      - - org.codehaus.jackson.map.ser.std.EnumMapSerializer

- All Implemented Interfaces:
    ResolvableSerializer, SchemaAware

      public class EnumMapSerializer
      extends ContainerSerializerBase<EnumMap<? extends Enum<?>,?>>
      implements ResolvableSerializer

  Specialized serializer for `EnumMap`s. Somewhat tricky to implement because actual Enum value type may not be available; and if not, it can only be gotten from actual instance.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected EnumValues` | `_keyEnums` If we know enumeration used as key, this will contain value set to use for serialization
    `protected BeanProperty` | `_property` Property being serialized with this instance
    `protected boolean` | `_staticTyping`
    `protected JsonSerializer<Object>` | `_valueSerializer` Value serializer to use, if it can be statically determined
    `protected JavaType` | `_valueType`
    `protected TypeSerializer` | `_valueTypeSerializer` Type serializer used for values, if any.

    - ### Fields inherited from class org.codehaus.jackson.map.ser.std.SerializerBase

      `_handledType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EnumMapSerializer(JavaType valueType, boolean staticTyping, EnumValues keyEnums, TypeSerializer vts, BeanProperty property)` Deprecated. Since 1.8, use variant that takes value serializer
    `EnumMapSerializer(JavaType valueType, boolean staticTyping, EnumValues keyEnums, TypeSerializer vts, BeanProperty property, JsonSerializer<Object> valueSerializer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ContainerSerializerBase<?>` | `_withValueTypeSerializer(TypeSerializer vts)`
    `JsonNode` | `getSchema(SerializerProvider provider, Type typeHint)` Note: since Jackson 1.9, default implementation claims type is "string"
    `void` | `resolve(SerializerProvider provider)` Method called after `SerializerProvider` has registered the serializer, but before it has returned it to the caller.
    `void` | `serialize(EnumMap<? extends Enum<?>,?> value, JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `protected void` | `serializeContents(EnumMap<? extends Enum<?>,?> value, JsonGenerator jgen, SerializerProvider provider)`
    `protected void` | `serializeContentsUsing(EnumMap<? extends Enum<?>,?> value, JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> valueSer)`
    `void` | `serializeWithType(EnumMap<? extends Enum<?>,?> value, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

    - ### Methods inherited from class org.codehaus.jackson.map.ser.std.ContainerSerializerBase

      `withValueTypeSerializer`

    - ### Methods inherited from class org.codehaus.jackson.map.ser.std.SerializerBase

      `createObjectNode, createSchemaNode, createSchemaNode, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonSerializer

      `isUnwrappingSerializer, unwrappingSerializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _staticTyping

          protected final boolean _staticTyping

    - #### _keyEnums

          protected final EnumValues _keyEnums

      If we know enumeration used as key, this will contain value set to use for serialization

    - #### _valueType

          protected final JavaType _valueType

    - #### _property

          protected final BeanProperty _property

      Property being serialized with this instance
      Since:
        1.7

    - #### _valueSerializer

          protected JsonSerializer<Object> _valueSerializer

      Value serializer to use, if it can be statically determined
      Since:
        1.5

    - #### _valueTypeSerializer

          protected final TypeSerializer _valueTypeSerializer

      Type serializer used for values, if any.

  - ### Constructor Detail

    - #### EnumMapSerializer

          @Deprecated
          public EnumMapSerializer(JavaType valueType,
                                      boolean staticTyping,
                                      EnumValues keyEnums,
                                      TypeSerializer vts,
                                      BeanProperty property)

      Deprecated. Since 1.8, use variant that takes value serializer

    - #### EnumMapSerializer

          public EnumMapSerializer(JavaType valueType,
                           boolean staticTyping,
                           EnumValues keyEnums,
                           TypeSerializer vts,
                           BeanProperty property,
                           JsonSerializer<Object> valueSerializer)

  - ### Method Detail

    - #### _withValueTypeSerializer

          public ContainerSerializerBase<?> _withValueTypeSerializer(TypeSerializer vts)

      Specified by:
        `_withValueTypeSerializer` in class `ContainerSerializerBase<EnumMap<? extends Enum<?>,?>>`

    - #### serialize

          public void serialize(EnumMap<? extends Enum<?>,?> value,
                       JsonGenerator jgen,
                       SerializerProvider provider)
                         throws IOException,
                                JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `SerializerBase<EnumMap<? extends Enum<?>,?>>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### serializeWithType

          public void serializeWithType(EnumMap<? extends Enum<?>,?> value,
                               JsonGenerator jgen,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws IOException,
                                        JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will ignore serialization of type information, and just calls `JsonSerializer.serialize(T, org.codehaus.jackson.JsonGenerator, org.codehaus.jackson.map.SerializerProvider)`: serializers that can embed type information should override this to implement actual handling. Most common such handling is done by something like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, jgen);
            serialize(value, jgen, provider);
            typeSer.writeTypeSuffixForScalar(value, jgen);

      Overrides:
        `serializeWithType` in class `JsonSerializer<EnumMap<? extends Enum<?>,?>>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### serializeContents

          protected void serializeContents(EnumMap<? extends Enum<?>,?> value,
                               JsonGenerator jgen,
                               SerializerProvider provider)
                                    throws IOException,
                                           JsonGenerationException

      Throws:
        `IOException`
        `JsonGenerationException`

    - #### serializeContentsUsing

          protected void serializeContentsUsing(EnumMap<? extends Enum<?>,?> value,
                                    JsonGenerator jgen,
                                    SerializerProvider provider,
                                    JsonSerializer<Object> valueSer)
                                         throws IOException,
                                                JsonGenerationException

      Throws:
        `IOException`
        `JsonGenerationException`

    - #### resolve

          public void resolve(SerializerProvider provider)
                       throws JsonMappingException

      Description copied from interface: `ResolvableSerializer`
      Method called after `SerializerProvider` has registered the serializer, but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).
      Specified by:
        `resolve` in interface `ResolvableSerializer`
      Parameters:
        `provider` - Provider that has constructed serializer this method is called on.
      Throws:
        `JsonMappingException`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           Type typeHint)
                             throws JsonMappingException

      Description copied from class: `SerializerBase`
      Note: since Jackson 1.9, default implementation claims type is "string"
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `SerializerBase<EnumMap<? extends Enum<?>,?>>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.
      Throws:
        `JsonMappingException`